/*
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

package com.packtpub.learningcypher.chapter5.model;

/**
 * Number of citations of the specified entity.
 
 * @param <Entity> Entity which could be cited
 * @author Onofrio Panzarino
 */
public abstract class CitedStats<Entity> {
    
    public abstract Entity getEntity();
    public abstract int getCitations();

    @Override
    public String toString() {
        return getEntity() + " was cited " + getCitations() + " times.";
    }    
}
